// https://binary-system.base-conversion.ro/real-number-converted-from-decimal-system-to-32bit-single-precision-IEEE754-binary-floating-point.php?decimal_number_base_ten=7

#include <stdio.h>

void print_byte(char *pbyte)
{
  char byte = *pbyte;
	for (int i = 0; i<8; i++)
	{
		int bit = byte & 256;
		printf("%d-", bit >> 8);
		byte = byte << 1;
	}
	printf("\n");
}

int main(int argc, char *argv[])
{
	float flt  = 1.123456789123456789;
	double dbl = 1.123456789123456789;

	printf("flt = %.18f\n", flt);
	printf("dbl = %.18f\n", dbl);

	float f = 7.0;
	printf("f = %f\n", f);

	char *p = (char *)&f;
	print_byte(&p[3]);
	print_byte(&p[2]);
	print_byte(&p[1]);
	print_byte(&p[0]);
	return 0;
}

